
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>常用的SQL注入攻击方法总结 / iVAN</title>

    <meta name="description" content="常用的SQL注入攻击方法总结 1. 没有正确过滤转义字符 在用户的输入没有转义字符过滤时,就会发生这种形式的注入或攻击,它会被传递给一个SQL语句.这样就会导致应用程序的终端用户对数据库上的语句实施操作.比方说,下面的这行代码就会演示这种漏洞:  代码如下 复制代码 &quot;SELECT * FROM users WHERE name = ' &quot; + userName + &quot; ' ;&quot; 这种代码的设计目的是将一个特定的用户从其用户表中取出,但是,如果用户名被一个恶意的用户用一种特定的方式伪造 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">常用的SQL注入攻击方法总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>1. 没有正确过滤转义字符</p>
<p>在用户的输入没有转义字符过滤时，就会发生这种形式的注入或攻击，它会被传递给一个SQL语句。这样就会导致应用程序的终端用户对数据库上的语句实施操作。比方说，下面的这行代码就会演示这种漏洞：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />"SELECT * FROM users WHERE name = ' " + userName + " ' ;"</p>
</td>
</tr>
</table>
<p>这种代码的设计目的是将一个特定的用户从其用户表中取出，但是，如果用户名被一个恶意的用户用一种特定的方式伪造，这个语句所执行的操作可能就不仅仅是代码的作者所期望的那样了。例如，将用户名变量（即username）设置为：a' or 't' = 't，此时原始语句发生了变化：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />SELECT * FROM users WHERE name = 'a' OR 't' = 't';</p>
</td>
</tr>
</table>
<p>如果这种代码被用于一个认证过程，那么这个例子就能够强迫选择一个合法的用户名，因为赋值 't' = 't' 永远是正确的。</p>
<p>在一些SQL服务器上，如在SQL Server中，任何一个SQL命令都可以通过这种方法被注入，包括执行多个语句。下面语句中的username的值将会导致删除"users"表，又可以从"data"表中选择所有的数据（实际上就是透露了每一个用户的信息）。</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />a';DROP TABLE users; SELECT * FROM data WHERE name LIKE '%</p>
</td>
</tr>
</table>
<p>使得最后的SQL语句变成下面这个样子：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />SELECT * FROM users WHERE name = 'a';DROP TABLE users; SELECT * FROM data WHERE name LIKE '%';</p>
</td>
</tr>
</table>
<p>其它的SQL执行不会将执行同样查询中的多个命令作为一项安全措施。这会防止攻击者注入完全独立的查询，不过却不会阻止攻击者修改查询。</p>
<p>2. Incorrect type handling</p>
<p>如果一个用户提供的字段并非一个强类型，或者没有实施类型强制，就会发送这种形式的攻击。当在一个SQL语句中使用一个数字字段时，如果程序员没有检查用户输入的合法性（是否为数字型）就会发生这种攻击。例如：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />"SELECT * FROM data WHERE id = " + a_variable + ";"</p>
</td>
</tr>
</table>
<p>从这个语句可以看出，作者希望a_variable是一个与"id"字段有关的数字。不过，如果终端用户选择一个字符串，就绕过了对转义字符的需要。例如，将a_variable设置为：1; DROP TABLE users，它会将"users"表从数据库中删除，SQL语句变成：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />SELECT * FROM data WHERE id = 1; DROP TABLE users;</p>
</td>
</tr>
</table>
<p>3. 数据库服务器中的漏洞</p>
<p>有时，数据库服务器软件中也存在漏洞，如MYSQL服务器中mysql_real_escape_string()函数漏洞。这种漏洞允许一个攻击者根据错误的统一字符编码执行一次成功的SQL注入式攻击。</p>
<p>4. 盲目SQL注入式攻击</p>
<p>当一个Web应用程序易于遭受攻击而其结果对攻击者却不见时，就会发生所谓的盲目SQL注入式攻击。有漏洞的网页可能并不会显示数据，而是根据注入到合法语句中的逻辑语句的结果显示不同的内容。这种攻击相当耗时，因为必须为每一个获得的字节而精心构造一个新的语句。但是一旦漏洞的位置和目标信息的位置被确立以后，一种称为Absinthe的工具就可以使这种攻击自动化。</p>
<p>5. 条件响应</p>
<p>注意，有一种SQL注入迫使数据库在一个普通的应用程序屏幕上计算一个逻辑语句的值：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">
<br />SELECT booktitle FROM booklist WHERE bookId = 'OOk14cd' AND 1=1</p>
</td>
</tr>
</table>
<p>这会导致一个标准的画面，而语句</p>
<p>SELECT booktitle FROM booklist WHERE bookId = 'OOk14cd' AND 1=2 在页面易于受到SQL注入式攻击时，它有可能给出一个不同的结果。如此这般的一次注入将会证明盲目的SQL注入是可能的，它会使攻击者根据另外一个表中的某字段内容设计可以评判真伪的语句。</p>
<p>6. 条件性差错</p>
<p>如果WHERE语句为真，这种类型的盲目SQL注入会迫使数据库评判一个引起错误的语句，从而导致一个SQL错误。例如：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">SELECT 1/0 FROM users WHERE username='Ralph'。</td>
</tr>
</table>
<p>显然，如果用户Ralph存在的话，被零除将导致错误。</p>
<p>7. 时间延误</p>
<p>时间延误是一种盲目的SQL注入，根据所注入的逻辑，它可以导致SQL引擎执行一个长队列或者是iyige时间延误语句。攻击者可以衡量页面加载的时间，从而决定所注入的语句是否为真。</p>
<p>以上仅是对SQL攻击的粗略分类。但从技术上讲，如今的SQL注入攻击者在如何找出有漏洞的网站方面更加聪明，也更加全面了。出现了一些新型的SQL攻击手段。黑客们可以使用各种工具来加速漏洞的利用过程。我们不妨看看the Asprox Trojan这种木马，它主要通过一个发布邮件的僵尸网络来传播，其整个工作过程可以这样描述：首先，通过受到控制的主机发送的垃圾邮件将此木马安装到电脑上，然后，受到此木马感染的电脑会下载一段二进制代码，在其启动时，它会使用seo/seo.html" target="_blank"&gt;搜索引擎搜索用微软的ASP技术建立表单的、有漏洞的网站。搜索的结果就成为SQL注入攻击的靶子清单。接着，这个木马会向这些站点发动SQL注入式攻击，使有些网站受到控制、破坏。访问这些受到控制和破坏的网站的用户将会受到欺骗，从另外一个站点下载一段恶意的JavaScript代码。最后，这段代码将用户指引到第三个站点，这里有更多的恶意软件，如窃取口令的木马。</p>
<p>以前，我们经常警告或建议Web应用程序的程序员对其代码进行测试并打补丁，虽然SQL注入漏洞被发现和利用的几率并不太高。但近来攻击者越来越多地发现并恶意的利用这些漏洞。因此，在部署其软件之前，开发人员应当更加主动地测试其代码，并在新的漏洞出现后立即对代码打补丁。</p>
<p>例如，某些人可能会在登陆窗口使用这种方法绕开登陆。如果你的查询用户名和密码的形式类似这样子：</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">[code='sql']<br />
SELECT * FROM users WHERE username = {username} AND<br />
password = {password }<br />
[/code]<br />
那么用户可以使用任意的用户名，使用这个密码：<br />
[code='sql']' OR ''=''[/code]<br />
从而使得你的验证用户名密码的MySQL查询变成：<br />
[code='sql']<br />
SELECT * FROM users WHERE username = 'anyuser' AND<br />
password = '' OR ''=''<br />
[/code]
</td>
</tr>
</table>
<p>由于空串总是等于空串，所以查询条件永真。因此可以看到，MySQL注入的风险还是很大的，因为攻击者可以看到那些本来应该通过登陆才能访问的数据。防止你的网站受到注入式攻击是非常重要的。幸运的是，PHP可以帮助我们防止注入式攻击。<br />
MySQL将会返回表中的所有行，根据你的程序逻辑，可能会导致全部用户都登陆了，因为他们都被匹配到了。现在，大部分情况下，人们会打开magic_quotes_gpc选项(也是PHP的默认情况)，这样的配置将会自动添加反斜线，转义全部'(单引号)，"(双引号)，(反斜线)和空字符。但事情并不是这么简单就能解决，因为并不是所有的会导致风险的字符都被转义了。PHP有一个函数可以转义全部可能带来多余SQL子句的MySQL字符。这个函数就是mysql_real_escape_string()。<br />
使用这个函数的时候要小心，因为你可能已经打开了magic_quotes_gpc选项，这时候使用mysql_real_escape_string()会导致第二次转义。下面这个函数避免了这个问题，首先判断<br />
magic_quotes_gpc选项是否打开，然后再决定是否执行mysql_real_escape_string()。<br />
[code='php']</p>
<table>
<tr>
<td> 代码如下</td>
<td>复制代码</td>
</tr>
<tr>
<td colspan="2">//给变量加引号以保证安全<br />
function quote_smart($value)<br />
{<br />
$link=mysql_connect('mysql_host','mysql_user','mysql_password');<br />
//去转义<br />
if(get_magic_quotes_gpc())<br />
{<br />
$value=stripslashes($value);<br />
}<br />
//给所有非数字加引号<br />
if(!is_numeric($value))<br />
{<br />
$value="'".mysql_real_escape_string($value,$link)."'";<br />
}<br />
return $value;<br />
}<br />
?&gt;</td>
</tr>
</table>
<p>[/code]<br />
需要注意的是，quote_smart()函数会自动给字符串加引号，因此你不需要自己加。<br />
另外需要注意，因为不同的MySQL版本对于过滤的要求不一样，mysql_real_escape_string()需要一个MySQL连接才能工作，因此必须第二个参数传入一个MySQL连接。在本机安装MySQL的情况，可以省略，但是如果本机没有装MySQL，或者远程连接到MySQL，则这个参数必不可少，否则mysql_real_escape_string()将返回一个空字符串。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 19:12:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%94%a8%e6%88%b7/" title="用户">用户</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>常用的SQL注入攻击方法总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm38y7b.html" rel="bookmark">Nginx防范Sql注入攻击方法总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本sql注入原理: 通过union all 联合查询获取其他表的内容(如user表的用户密码) 防御原理: 1. 通过以上配置过滤基本的url中的注入关键字: 2. 当然,数据库中的用户密码得加密存放 : 3. php程序进行二次过滤,过滤GET和POST变量中的关键字: 4. 生产环境关闭PHP和MySQL的错误信息. 对于简单的情况,比如包含单引号' , 分号;, &lt;, &gt;, 等字符可通过rewrite直接重订向到404页面来避免.   用rewrite有个前提需要知道,一般用rewri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW7ZXmM.html" rel="bookmark">php安全-防止sql注入攻击简单方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法一:密码比对 思路:首先通过用户输入的用户名去查询数据库,得到该用户名在数据库中对应的密码,再将从数据库中查询到的密码和用户提交过来的密码进行比对. 代码:   代码如下 复制代码        $sql=&quot;select password from users where username='$name'&quot;;        $res=mysql_query($sql,$conn);        if ($arr=mysql_fetch_assoc($res)){//如果用户名存在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Edaoz.html" rel="bookmark">Nginx防止SQL注入攻击配置方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				防御原理: 1. 通过以上配置过滤基本的url中的注入关键字: 2. 当然,数据库中的用户密码得加密存放 : 3. php程序进行二次过滤,过滤GET和POST变量中的关键字: 4. 生产环境关闭PHP和MySQL的错误信息. SQL注入攻击一般问号后面的请求参数,在nginx用$query_string表示 例如,对于参数中带有单引号的'进行匹配然后定向到错误页面, /plus/list.php?tid=19&amp;mid=1124'  代码如下 复制代码 rewrite ^.*([;'&lt;&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VzwEQkM.html" rel="bookmark">PHP与SQL注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				攻击     SQL注入攻击是黑客攻击网站最常用的手段.如果你的站点没有使用严格的用户输入检验,那么常容易遭到SQL注入攻击.SQL注入攻击通常通过给站点数据库提交不良的数据或查询语句来实现,很可能使数据库中的纪录遭到暴露,更改或被删除.下面来谈谈SQL注入攻击是如何实现的,又如何防范. 看这个例子: // supposed input$name = &quot;ilia'; DELETE FROM users;&quot;;mysql_query(&quot;SELECT * FROM users WH			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7kXPXz.html" rel="bookmark">如何保证SQL Server免遭SQL注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL注入攻击可能是黑客攻击面向互联网的SQL Server数据库最常用的方式.任何使用动态SQL.允许未经检验的用户输入提交到数据库的应用程序都面临SQL注入攻击的风险,无论你的网络有多安全,或者你安装了多少防火墙.最近有一项关于Web黑客攻击的报告显示,SQL注入攻击呈上升趋势,不仅仅导致数据盗窃和数据丢失,而且在最近一连串的自动注入攻击中,数据库被破坏,向用户提供恶意Java脚本.这种渗透导致Web服务器令客户端电脑感染上其它的病毒.报告对于已经遭到攻击的网站数量统计不一,不过,哪怕是最低			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXOD4z.html" rel="bookmark">php安全编程&mdash;sql注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:php安全编程-sql注入攻击 php安全编程--sql注入攻击 定义 SQL注入攻击指的是通过构建特殊的输入作为参数传入Web应用程序,而这些输入大都是SQL语法里的一些组合,通过执行SQL语句进而执行攻击者所要的操作,其主要原因是程序没有细致地过滤用户输入的数据,致使非法数据侵入系统. 根据相关技术原理,SQL注入可以分为平台层注入和代码层注入.前者由不安全的数据库配置或数据库平台的漏洞所致:后者主要是由于程序员对输入未进行细致地过滤,从而执行了非法的数据查询.基于此,SQL注入的产生			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYvJab.html" rel="bookmark">细谈php中SQL注入攻击与XSS攻击&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				例如: SQL注入攻击 XSS攻击 复制代码 代码如下: 任意执行代码 文件包含以及CSRF. } 关于SQL攻击有很多文章还有各种防注入脚本,但是都不能解决SQL注入的根本问题 见代码: 复制代码 代码如下: &lt;?php mysql_connect(&quot;localhost&quot;,&quot;root&quot;,&quot;123456&quot;)or die(&quot;数据库连接失败!&quot;); mysql_select_db(&quot;test1&quot;); $u			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4WL6M.html" rel="bookmark">使用SQLMAP对网站和数据库进行SQL注入攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				from:http://www.blackmoreops.com/2014/05/07/use-sqlmap-sql-injection-hack-website-database/ 0x00 背景介绍 1. 什么是SQL注入? SQL注入是一种代码注入技术,过去常常用于攻击数据驱动性的应用,比如将恶意的SQL代码注入到特定字段用于实施拖库攻击等.SQL注入的成功必须借助应用程序的安全漏洞,例如用户输入没有经过正确地过滤(针对某些特定字符串)或者没有特别强调类型的时候,都容易造成异常地执行SQL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9Mx5wOp.html" rel="bookmark">SQL注入攻击&colon;防御和检查SQL注入的手段</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然前面有许多文章讨论了SQL注入,但今天所讨论的内容也许可帮助你检查自己的服务器,并采取相应防范措施.知彼知己,方可取胜.首先要清楚SQL注入攻击有哪些种类. 观察近来的一些安全事件及其后果,安全专家们已经得到一个结论,这些威胁主要是通过SQL注入造成的.虽然前面有许多文章讨论了SQL注入,但今天所讨论的内容也许可帮助你检查自己的服务器,并采取相应防范措施. SQL注入攻击的种类 知彼知己,方可取胜.首先要清楚SQL注入攻击有哪些种类. 1.没有正确过滤转义字符 在用户的输入没有为转义字符过滤			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqZ9Kp.html" rel="bookmark" class="title">用C&num;编写发手机中文短信息Windows服务</a>
					<div>
						window|中文 最近在电脑城上买了一根NOKIA3210的数据线,玩了几天改LOGO.改铃声后也将数据线扔在一边.直到前几天在Http://oxygensoftware.com上看到有发手机短信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2OvqM.html" rel="bookmark" class="title">C&num;中使用Spread6&period;0全攻略</a>
					<div>
						攻略 (一)在C#中加载Spread6.0 nmd002版&lt;C#加载Spread6.0全攻略&gt; 首先,在引用里加载Spread6.0的Dll文件.(如果你先安了C#,再安的Spread有可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdZ44b.html" rel="bookmark" class="title">SEO推广之&OpenCurlyDoubleQuote;百度知道品牌推广&rdquo;建立相关搜索</a>
					<div>
						相信&quot;百度知道&quot;对大家都不会陌生.也有很多Seoer们都在利用百度知道这个平台做着各种目的的推广.最近武汉SEO柯伟也利用下班之后的时间,拿自己的SEO博客,针对百度知道做了一个小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK353M.html" rel="bookmark" class="title">Oracle临时表空间问题解决的例子</a>
					<div>
						今天一哥们讲OA里面的某些模块失效了,一查系统日志,原来是Oracle数据库的临时表空间满了,中午吃饭的时候就把数据库重启一下(这种方式最简便也不容易出错),没想到临时表空间还是有问题,后面进行如下处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze40v9p.html" rel="bookmark" class="title">VRay渲染器轻松实现焦散效果</a>
					<div>
						焦散概述 焦散特效最能体现&quot;间接照明&quot;的概念,因为在镜面反射中,光线几乎可以保持来自光源的全部能量,并在表面曲度和折射率的作用下,产生聚焦或者发散,当这种光线接触到场景中其它对象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLoeZb.html" rel="bookmark" class="title">Java&colon;无处不在的线程</a>
					<div>
						谁创建线程? 即使您从未显式地创建一个新线程,您仍可能会发现自己在使用线程.线程被从各种来源中引入到我们的程序中. 有许多工具可以为您创建线程,如果要使用这些工具,应该了解线程如何交互,以及如何防止线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNAADb.html" rel="bookmark" class="title">紧急恢复受损的Windows操作系统</a>
					<div>
						很多时候我们会发现自己的系统问题越来越多,如果将就使用,那系统运行效率肯定不会很高,甚至还无法正常运行,如果选择重新安装系统,那不但麻烦不说,而且还会耗费很长的等待时间.其实,当Windows系统一旦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB7EWb.html" rel="bookmark" class="title">Photoshop制作雨滴下落的下雨效果GIF动画</a>
					<div>
						制作动画之前需要把雨滴单独做出来,然后根据自己的思路设定动画展示效果.如果雨滴过多不太好控制,可以先新建一个较大的画布,把雨滴复制并排列好,最后用整张图片来做动画即可.         三联推荐:ph ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2N0kb.html" rel="bookmark" class="title">如何找回2345智能浏览器隐藏的菜单栏？</a>
					<div>
						咦?突然发现菜单栏不见了,如下图所示.不用着急,小编教你快速找回. 右键2345智能浏览器顶部任意空白处,可以自定义菜单,在你要的栏目前打钩.如图所示,你还只要勾选菜单栏就可以马上找回你的菜单栏了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6V5Ez.html" rel="bookmark" class="title">192&period;168&period;1&period;1 路由器设置密码步骤是什么</a>
					<div>
						192.168.1.1 路由器设置密码步骤是什么? 路由器具有判断网络地址和选择IP路径的功能,它能在多网络互联环境中,建立灵活的连接,可用完全不同的数据分组和介质访问方法连接各种子网.路由器分本地路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7JmDb.html" rel="bookmark" class="title">Win7中IE浏览器假死不能操作网页怎么办</a>
					<div>
						  1.打开IE浏览器,IE浏览器右上角的齿轮图标,在弹出的菜单中点击&quot;Internet选项&quot;. 2.如果是第三方采用IE内核的浏览器,请点击&quot;菜单&quot;→&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7NNAM.html" rel="bookmark" class="title">福昕阅读器书签功能怎么使用</a>
					<div>
						  福昕PDF阅读器作为一款功能全面的pdf阅读器,它除了拥有强大的PDF阅读功能以外,还具有强大的高级编辑功能,如创建编辑PDF.插入图片.连接.多媒体.动画.书签等操作,不过很多用户不知道如何使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGBR1p.html" rel="bookmark" class="title">Windows XP加密分区的文件</a>
					<div>
						  问:我用的是Windows XP,并且将整个D分区都使用Windows XP的加密功能加密了,最近由于系统出现了故障,我就把安装了Windows XP的C分区进行了格式化并重装了Windows X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8GYmp.html" rel="bookmark" class="title">用WinToFlash制作U盘启动的方法</a>
					<div>
						  U盘变系统安装盘,有了WinToFlash软件,一切都变得非常简单,它是一个制作优盘系统盘的软件,支持Windows XP.2003.Windows Vista.Windows 2008和Wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlByPDz.html" rel="bookmark" class="title">eaacelerator配置样例</a>
					<div>
						[eaccelerator] zend_extension=&quot;/usr/local/php/ext/eaccelerator.so&quot; eaccelerator.shm_size=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYV2kM.html" rel="bookmark" class="title">为何我会喜欢封闭的apple？</a>
					<div>
						    原来本猫喜欢的手机是简单的塞班系统,nokia的E72i,超经典吧!就是最近都有把它充满电重新拿出来用的冲动呀.可惜无奈的是上面的应用太少呀!原来PC和笔记本装的是各种清一色的windows系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwakdp.html" rel="bookmark" class="title">PHP导出带样式的Excel示例代码&lowbar;php实例</a>
					<div>
						前言 在大家工作中做导出的时候,需要导出自定义的表格或嫌弃导出的Excel格式太难看了.这时候就需要设置颜色.字号大小.加粗.合并单元格等等.这篇文章通过实例告诉大家怎么做,下面来一起看看. 先来看看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj4BBp.html" rel="bookmark" class="title">仿360在Launcher画面显示内存使用率的浮窗&lpar;基础版&rpar;</a>
					<div>
						MainActivity如下: package cc.cc; import android.os.Bundle; import android.view.View; import android.vi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr3L6M.html" rel="bookmark" class="title">两种虚拟主机全备份方法介绍</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 相信每个站长都会意识到备份的重要性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDRnkz.html" rel="bookmark" class="title">Android的兼容性问题剖析</a>
					<div>
						1.PC是X86构架,主要生产厂是Inter和AMD,android智能手机基本上都是ARM构架,主要生产厂家有高通.三星.NVIDIA等,也不是很多,所以架构方面应该不是导致碎片化的主要原因才是啊? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRoRAb.html" rel="bookmark" class="title">指针-C&plus;&plus; 数组整体求模问题，求指导</a>
					<div>
						问题描述 C++ 数组整体求模问题,求指导 现在有一个16000的复数指针complex,将它理解为一个二维数组 Rn = complex[n][0]是实部,In = complex[n][1]是虚部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZamKp.html" rel="bookmark" class="title">【百度地图API】批量地址解析与批量反地址解析（带商圈数据）</a>
					<div>
						原文:[百度地图API]批量地址解析与批量反地址解析(带商圈数据) 摘要:因为地址解析的webserives方式还没有开通,所以先用JS版本的地址解析接口来批量获取地址解析数据吧,同时还能得到商圈的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJEmvp.html" rel="bookmark" class="title">private Dictionary&amp;amp&semi;amp&semi;lt&semi;string&comma; PluginEngine&period;ICommand&amp;amp&semi;amp&semi;gt&semi; &lowbar;CommandCol &equals; null&semi;怎么在c&plus;&plus;MFC实现</a>
					<div>
						问题描述 vs2010C#中privateDictionary&lt;string,PluginEngine.ICommand&gt;_CommandCol=null;到了VS平台托管的c++MFC中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZyRkp.html" rel="bookmark" class="title">遇到问题产品经理如何处理</a>
					<div>
						这种情况大家常常会碰到: 技术:这个功能不能实现,你们想办法吧. 销售:这产品不好卖,价格太高了,这类产品市场接受不了. UI/视觉:这不是我的风格,其它产品同样这么设计的. 老板:这东西怎么卖钱,为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qxx4M.html" rel="bookmark" class="title">android 开发教程之日历项目实践&lpar;一&rpar;&lowbar;Android</a>
					<div>
						前言:决定开始学习 Android 平台下的软件开发,以日历作为实践项目,进行一周后,基本完成. 为了总结及笔记,并给有需要的朋友借鉴,开始整理本教程. 开始之前: 在编写程序之前,需要进行项目设计, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jXGkp.html" rel="bookmark" class="title">C&plus;&plus;实现简单的职工信息管理系统&lowbar;C 语言</a>
					<div>
						功能主模块描述 模块一:增加人员函数Add():增加职工基本信息. 模块二:删除人员函数Delete():删除指定的职工的基本信息以及薪酬. 模块三:修改人员函数Modify():修改指定的职工基本信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZkNqb.html" rel="bookmark" class="title">使用javascript为网页增加夜间模式&lowbar;javascript技巧</a>
					<div>
						HTML+CSS: 复制代码 代码如下: &lt;div class=&quot;cover&quot;&gt;&lt;/div&gt; 复制代码 代码如下: &lt;style&gt;.cover{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYBEob.html" rel="bookmark" class="title">美光财报：Q4季度NAND闪存市场供应紧张</a>
					<div>
						随着2016年即将结束,各大存储厂商的2016财年的年报也纷纷出炉. 日前,存储大厂美光公布了截止到9月1日的2016财年Q4季度财报,显示2016财年总营收为123.99亿美金,与2015财年161 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyRNmM.html" rel="bookmark" class="title">LinkedIn第三季度净亏损430万美元 同比扩大</a>
					<div>
						DoNews 10月31日消息 LinkedIn今日发布了2014年第三季度财务报告.报告显示,公司该季度营收5.68亿美元,同比增长45%:归属股东部分的净亏损为430万美元,去年同期为净亏损340 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWnEWp.html" rel="bookmark" class="title">匿名分享应用Secret融资1000万 拟拓展全球市场</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 网易科技讯 4月29日消息,据国外 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
